Unit AFH5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFH5R(N :Integer; NV :Integer; var A :Array of Real;
                var D :Array of Real; var E :Array of Real;
                var E2 :Array of Real);

implementation

procedure AFH5R(N :Integer; NV :Integer; var A :Array of Real;
                var D :Array of Real; var E :Array of Real;
                var E2 :Array of Real);
var
I,II,IZ,J,JK,K,L :Integer;
F,G,H,HH,SCALE :Real;
const
SYS056 :Real = 2.9E-39;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110;
begin
{   I = N,1,-1 }
for II:=1 to N do
 begin
  I := N + 1 - II;
  L := I - 1;
  IZ := (I*L) div 2;
  H := 0.0;
  SCALE := 0.0;
  if ( L <  1 ) 
   then goto _30;
{   HOPM-KA CTPOK }
  for K:=1 to L do
   begin
    IZ := IZ + 1;
    D[K-1] := A[IZ-1];
    SCALE := SCALE + Abs(D[K-1]);
_10:
   end;
  if ( SCALE >  SYS056 ) 
   then goto _40;
  JK := IZ - L;
  for K:=1 to L do
   begin
    JK := JK + 1;
    A[JK-1] := 0.0;
_20:
   end;
  SCALE := 0.0;
_30:
  E[I-1] := 0.0;
  E2[I-1] := 0.0;
  goto _100;
_40:
  F := 1.0/SCALE;
  for K:=1 to L do
   begin
    D[K-1] := D[K-1]*F;
    H := H + D[K-1]*D[K-1];
_50:
   end;
  E2[I-1] := SCALE*SCALE*H;
  F := D[L-1];
  G := -Sign(Sqrt(H),F);
  E[I-1] := SCALE*G;
  H := H - F*G;
  D[L-1] := F - G;
  A[IZ-1] := SCALE*D[L-1];
  if ( L =  1 ) 
   then goto _100;
  F := 0.0;
  for J:=1 to L do
   begin
    G := 0.0;
    JK := (J*(J - 1)) div 2;
{   OPM-E  A*U }
    for K:=1 to L do
     begin
      JK := JK + 1;
      if ( K >  J ) 
       then JK := JK + K - 2;
      G := G + A[JK-1]*D[K-1];
_60:
     end;
{   OPM-E BEKTOPA  A*U/H }
    E[J-1] := G/H;
    F := F + E[J-1]*D[J-1];
_70:
   end;
  HH := F/(H + H);
  JK := 0;
{   PEOPAOBAHE MATP A }
  for J:=1 to L do
   begin
    F := D[J-1];
    G := E[J-1] - HH*F;
    E[J-1] := G;
    for K:=1 to J do
     begin
      JK := JK + 1;
      A[JK-1] := A[JK-1] - F*E[K-1] - G*D[K-1];
_80:
     end;
_90:
   end;
_100:
  D[I-1] := A[IZ+0];
  A[IZ+0] := SCALE*Sqrt(H);
_110:
 end;
end;

end.
